Subject: Re: [PATCH] fix heartbeat

From: Val Henson <[email-masked]>
Date: Sat, 9 Feb 2002 17:23:53 -0700

On Sat, Feb 09, 2002 at 05:50:47PM +1100, Paul Mackerras wrote:
> Val Henson writes:
> >
> > The heartbeat function will not execute properly on Gemini without
> > this patch. (Check for cpu 0 removed from gemini_heartbeat.)
>
> CHRP needs the heartbeat function called on all cpus, IIRC.
>
> Clearly the heartbeat_count needs to be per-cpu or else pushed into
> the heartbeat function.  How about we make it just
>
> 	if (ppc_md.heartbeat)
> 		ppc_md.heartbeat();
>
> and let the heartbeat function do the if (!smp_processor_id()) and the
> if (!heartbeat_count--) if it wants?

Ah, I see, the heartbeat_count is now being decremented once per timer
interrupt, instead of smp_nr_cpus times per timer interrupt.  Last
time I checked, it was still possible for the heartbeat count to go
negative.

It's fine the way it is.  Sorry for the unnecessary patch.

-VAL

** Sent via the linuxppc-dev mail list. See http://lists.linuxppc.org/